﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Demo.Threading.Parallel
{

    class Program
    {
        static void Main(string[] args)
        {
            List<Employee> empList = new List<Employee>()
            {
                new Employee(){EmployeeID=1},
                new Employee(){EmployeeID=2},
                new Employee(){EmployeeID=3},
                new Employee(){EmployeeID=4},
                new Employee(){EmployeeID=5},
                new Employee(){EmployeeID=6},
                new Employee(){EmployeeID=7},
                new Employee(){EmployeeID=8},
            };

            Console.WriteLine("Start Operation {0}", DateTime.Now);

            System.Threading.Tasks.Parallel.ForEach(empList, (e) => e.ProcessEmployeeInformation());

            Console.WriteLine("End Operation {0}", DateTime.Now);

            Console.WriteLine("Start Operation {0}", DateTime.Now);

            //List<Task> taskList = new List<Task>();
            //foreach (Employee e in empList)
            //{
            //    Task t = Task.Factory.StartNew(() =>
            //    {
            //        e.ProcessEmployeeInformation();
            //    });
                
            //    taskList.Add(t);
                
            //}

            //foreach (Task t in taskList)
            //{
            //    t.Wait();
            //}

            Console.WriteLine("End Operation {0}", DateTime.Now);

            Console.WriteLine("Start Operation {0}", DateTime.Now);

            //new ParallelOptions().MaxDegreeOfParallelism = 4;

            System.Threading.Tasks.Parallel.For(0, 8, new ParallelOptions() { MaxDegreeOfParallelism = 4 }, (o) =>
            {
                Thread.Sleep(5000);
                Console.WriteLine("Thread ID - {0}", Thread.CurrentThread.ManagedThreadId);
            });

            Console.WriteLine("End Operation {0}", DateTime.Now);

            Console.WriteLine("Demo for Plink");

            Console.WriteLine("Start Operation {0}", DateTime.Now);
            var q = from e in empList.AsParallel().AsOrdered()
                    select new { ID = e.EmployeeID };

            foreach (var item in q)
            {
                Console.WriteLine(item.ID);
            }
            Console.WriteLine("End Operation {0}", DateTime.Now);

            System.Threading.Tasks.Parallel.For(0,1000,(int i, ParallelLoopState loopState) =>
            {
                if(i==500)
                   loopState.Break();
                   //or loopState.Stop();
                  return; // to ensure that this iteration also returns
                 //do stuff
            });

            Console.Read();
        }
    }

    class Employee
    {
        public Employee(){}

        public int EmployeeID {get;set;}

        public void ProcessEmployeeInformation()
        {
            Thread.Sleep(5000);
            Console.WriteLine("Processed Information for Employee {0}",EmployeeID);
        }
    }
}
