﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using Demo.Threading.WaitHandles;

namespace Demo.Threading.ResetEvents
{
    class Server
    {
        public Server() { }

        private object syncLock = new object();

        public void DoWork()
        {            
            Console.WriteLine("Work Starting ...");
            Thread.Sleep(5000);
            Console.WriteLine("Work Ended ...");
            ((AutoResetEvent)Global.GetHandle(Handles.AutoResetEvent)).Set();
        }

        public void DoWork(int threadID, int waitSingal)
        {
            Thread.Sleep(waitSingal);
            Console.WriteLine("Work Complete by Thread : {0} @ {1}", threadID, DateTime.Now.ToString("hh:mm:ss"));
            ((AutoResetEvent)Global.GetHandle(Handles.AutoResetEvent)).Set();
        }
        
        public void UpdateLog(int threadID)
        {
            if(((AutoResetEvent)Global.GetHandle(Handles.AutoResetEvent)).WaitOne(5000))
                Console.WriteLine("Update Log File by thread : {0} @ {1}", threadID, DateTime.Now.ToString("hh:mm:ss"));
            else
                Console.WriteLine("Time out");
        }

        public void SendMessages(bool monitorSingal)
        {            
            int counter=1;
            while (monitorSingal)
            {
                if (((ManualResetEvent)Global.GetHandle(Handles.ManualResetEvent)).WaitOne())
                {
                    Console.WriteLine("Sending message {0}", counter);
                    Thread.Sleep(3000);
                    counter += 1;
                }
            }
           
        }
    }
}
