﻿// Author - Anshu Dutta
// email - anshu.dutta@gmail.com
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Demo.Threading.Web
{
    public partial class Default : System.Web.UI.Page,ICallbackEventHandler
    {
        private string Result;

        protected void Page_Load(object sender, EventArgs e)
        {
            String cbReference = Page.ClientScript.GetCallbackEventReference(this,"arg", "ReceiveServerData", "context");
            
            String callbackScript;
            callbackScript = "function CallServer(arg, context)" + "{ " + cbReference + ";}";
            
            Page.ClientScript.RegisterClientScriptBlock(this.GetType(),"CallServer", callbackScript, true);
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            if (eventArgument!=null)
            {
                Result = this.LoadData(Convert.ToUInt16(eventArgument));
            }
            
        }

        public string GetCallbackResult()
        {
            return Result;
        }

        private string LoadData(int num)
        {
            // call Heavy data
            return Utility.LoadData(num);
        }

        
    }
}